# std::literals::string_literals::operator""s

From cppreference.com
< cpp‎ | string‎ | basic string

Defined in header `<string>` |  |
string operator "" s(const char *str, std::size_t len); | (1) | (since C++14)
u16string operator "" s(const char16_t *str, std::size_t len); | (2) | (since C++14)
u32string operator "" s(const char32_t *str, std::size_t len); | (3) | (since C++14)
wstring operator "" s(const wchar_t *str, std::size_t len); | (4) | (since C++14)

Forms a string literal of the desired type.

1) returns std::string{str, len}
2) returns std::u16string{str, len}
3) returns std::u32string{str, len}
4) returns std::wstring{str, len}

### Parameters

str | - | pointer to the beginning of the raw character array literal
len | - | length of the raw character array literal

### Return value

The string literal.

### Notes

These operators are declared in the namespace `std::literals::string_literals`, where both `literals` and `string_literals` are inline namespaces. Access to these operators can be gained with using namespace std::literals, using namespace std::string_literals, and using namespace std::literals::string_literals.

std::chrono::duration also defines `operator""s`, to represent literal seconds, but it is an arithmetic literal: 10.0s and 10s is ten seconds, but "10"s is a string.

### Example

Run this code

    #include <string>
    #include <iostream>

    int main()
    {
        using namespace std::string_literals;

        std::string s1 = "abc\0\0def";
        std::string s2 = "abc\0\0def"s;
        std::cout << "s1: " << s1.size() << " \"" << s1 << "\"\n";
        std::cout << "s2: " << s2.size() << " \"" << s2 << "\"\n";
    }

Possible output:

    s1: 3 "abc"
    s2: 8 "abc^@^@def"

### See also

(constructor) | constructs a `basic_string` (public member function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/string/basic_string/operator%22%22s&oldid=87203"